-- | functions to provide the same choice of function and variable names
--   as free-theorems does. The functions for name generation are provided
--   by Language.Haskell.FreeTheorems.NameStores. They are accessalbe only
--   from versions >=0.31 of the free-theorems package.
--   Additionally the letter for the term generated by ExFind is set here.

module Language.Haskell.FreeTheorems.Variations.CounterExamples.Internal.FTSync (funcNames,drelNames,varNames,termName) where

import Language.Haskell.FreeTheorems.NameStores

-- | name of the term ExFind produces
termName = "f"

-- | function names for type relations
--   termName is filtered because it is used for the output term.
funcNames = filter (/= termName) functionNameStore1

-- | function names for functions in the disrelater
--   termName is filtered because it is used for the output term.
drelNames = filter (/= termName) functionNameStore2

-- | variable names for variables in the disrelater
--   termName is filtered because it is used for the output term.
varNames  = filter (/= termName) variableNameStore

